
-- ###########################################
-- CLASS:Gui
Gui = class('Gui')

-- methods
function Gui:initialize()
	self.color = {255,255,255,255}
end

function Gui:draw()

end

-- ###########################################
-- CLASS:GuiPanel
GuiPanel = class('GuiPanel',Gui)

-- statics
GuiPanel.static.defaultSkin = love.graphics.newImage("media/ui/panel.png")
GuiPanel.static.defaultXtras = love.graphics.newImage("media/ui/panel_xtras.png")

GuiPanel.static.quads = {
	left_top = 		love.graphics.newQuad(0  ,0  ,20 ,20 ,232,232),
	right_top = 	love.graphics.newQuad(212,0  ,20 ,20 ,232,232),
	left_bottom = 	love.graphics.newQuad(0  ,212,20 ,20 ,232,232),
	right_bottom = 	love.graphics.newQuad(212,212,20 ,20 ,232,232),
	top =			love.graphics.newQuad(21 ,0  ,190,20 ,232,232),
	bottom =		love.graphics.newQuad(21 ,212,190,20 ,232,232),
	left =			love.graphics.newQuad(0  ,21 ,20 ,190,232,232),
	right =			love.graphics.newQuad(212,21 ,20 ,190,232,232),
	middle =		love.graphics.newQuad(20 ,20 ,190,190,232,232)
}

GuiPanel.static.xtraQuads = {
	left_top = 		love.graphics.newQuad(9  ,5  ,194,28 ,437,277),
	right_top = 	love.graphics.newQuad(276,8  ,153,36 ,437,277),
	left_bottom = 	love.graphics.newQuad(3  ,244,213,30 ,437,277),
	right_bottom = 	love.graphics.newQuad(221,245,213,29 ,437,277),
	title1 =		love.graphics.newQuad( 99, 49,246,60 ,437,277),
	title2 =		love.graphics.newQuad( 99,133,246,60 ,437,277),
	title3 =		love.graphics.newQuad( 99,191,246,60 ,437,277),
}

-- methods
function GuiPanel:initialize()
	self.skin = GuiPanel.defaultSkin
	self.xtraSkin = GuiPanel.defaultXtras
	self.x = 200
	self.y = 200
	self.width = 200
	self.height = 200
	self.title = ""
	self.xtra = {left_top=false ,right_top=false ,left_bottom=false ,right_bottom=false}
end

function GuiPanel:draw()
	-- corners
	love.graphics.drawq(self.skin, GuiPanel.quads.left_top, self.x, self.y )
	love.graphics.drawq(self.skin, GuiPanel.quads.right_top, self.x+self.width-20, self.y )
	love.graphics.drawq(self.skin, GuiPanel.quads.left_bottom, self.x, self.y+self.height-20 )
	love.graphics.drawq(self.skin, GuiPanel.quads.right_bottom, self.x+self.width-20, self.y+self.height-20 )
	-- sides
	love.graphics.drawseamless(self.skin, GuiPanel.quads.top, self.x+20, self.y, self.width-40, 20)
	love.graphics.drawseamless(self.skin, GuiPanel.quads.bottom, self.x+20, self.y+self.height-20, self.width-40, 20)
	love.graphics.drawseamless(self.skin, GuiPanel.quads.left, self.x, self.y+20, 20, self.height-40 )
	love.graphics.drawseamless(self.skin, GuiPanel.quads.right, self.x+self.width-20, self.y+20, 20, self.height-40)
	-- middle
	love.graphics.drawseamless(self.skin, GuiPanel.quads.middle, self.x+20, self.y+20, self.width-40, self.height-40)
	-- xtras
	if(self.xtra.left_top) then
		love.graphics.drawq(self.xtraSkin, GuiPanel.xtraQuads.left_top, self.x-6, self.y-6 )
	end
	if(self.xtra.right_top) then
		love.graphics.drawq(self.xtraSkin, GuiPanel.xtraQuads.right_top, self.x+self.width-147, self.y-6 )
	end
	if(self.xtra.left_bottom) then
		love.graphics.drawq(self.xtraSkin, GuiPanel.xtraQuads.left_bottom, self.x-6, self.y+self.height-20 )
	end
	if(self.xtra.right_bottom) then
		love.graphics.drawq(self.xtraSkin, GuiPanel.xtraQuads.right_bottom, self.x+self.width-204, self.y+self.height-20 )
	end
	if(self.title ~= '') then
		love.graphics.drawq(self.xtraSkin, GuiPanel.xtraQuads.title1, self.x+(self.width/2)-123, self.y-20)

		love.graphics.setColor(0,0,0,220)
		love.graphics.printf(self.title, self.x+(self.width/2)-122, self.y-3, 246, "center")
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf(self.title, self.x+(self.width/2)-123, self.y-2, 246, "center")
	end
end
