
-- Draw a seamless texture, repeating the quad as much as needed
function love.graphics.drawseamless(image, quad, x, y, width, height)

	if(quad == nil) then
		quad = love.graphics.newQuad(0, 0, image:getWidth(),image:getHeight(), image:getWidth(),image:getHeight())
	end

	local rendered = {w=0, h=0}
	local q = {}
	q.x, q.y, q.w, q.h = quad:getViewport()
	local render = love.graphics.newQuad(q.x, q.y, q.w, q.h, image:getWidth(),image:getHeight())
	local r = {x=q.x, y=q.y}

	local count = 0

	if(width < 1 or height < 1) then
		return(0)
	end

	while (rendered.w < width) do
		while (rendered.h < height) do

			if(rendered.w + q.w > width) then
				r.w = width - rendered.w
			else
				r.w = q.w
			end

			if(rendered.h + q.h > height) then
				r.h = height - rendered.h
			else
				r.h = q.h
			end

			render:setViewport(r.x, r.y, r.w, r.h)
			love.graphics.drawq(image, render, x+rendered.w, y+rendered.h )
			count = count+1
			
			rendered.h = rendered.h+r.h

		end

		rendered.h = 0
		rendered.w = rendered.w+r.w

	end

	return(count)

end